import FallBackComponent from './default-notion-components/FallbackComponent.svelte';
import Paragraph from './default-notion-components/Paragraph.svelte';
import Cover from './default-notion-components/layout/Cover.svelte';
import PageLayout from './default-notion-components/layout/PageLayout.svelte';
import Text from './default-notion-components/base/richtext/component/Text.svelte';
import Theme from './default-notion-components/layout/Theme.svelte';
import Heading1 from './default-notion-components/Heading1.svelte';
import Heading2 from './default-notion-components/Heading2.svelte';
import Heading3 from './default-notion-components/Heading3.svelte';
import Column from './default-notion-components/Column.svelte';
import ColumnList from './default-notion-components/ColumnList.svelte';
import NumberedListItem from './default-notion-components/NumberedListItem.svelte';
import BulletedListItem from './default-notion-components/BulletedListItem.svelte';
import Todo from './default-notion-components/Todo.svelte';
import CheckBox from './default-notion-components/base/CheckBox.svelte';
import Toggle from './default-notion-components/Toggle.svelte';
import Quote from './default-notion-components/Quote.svelte';
import Callout from './default-notion-components/Callout.svelte';
import Equation from './default-notion-components/Equation.svelte';
import Code from './default-notion-components/Code.svelte';
import Image from './default-notion-components/Image.svelte';
import Video from './default-notion-components/Video.svelte';
import Divider from './default-notion-components/Divider.svelte';
import Audio from './default-notion-components/Audio.svelte';
export class NotionComponentProvider {
    map;
    fallBackComponent;
    constructor(map, { fallBackComponent = FallBackComponent } = {}) {
        this.map = { ...defaultComponents, ...map };
        this.fallBackComponent = fallBackComponent;
    }
    register(key, component) {
        this.map[key] = component;
    }
    registerAll(map) {
        this.map = { ...this.map, ...map };
    }
    resolve(key) {
        const target = this.map[key];
        if (target === undefined) {
            return this.fallBackComponent;
        }
        return target;
    }
}
export const defaultComponents = {
    paragraph: Paragraph,
    heading_1: Heading1,
    heading_2: Heading2,
    heading_3: Heading3,
    cover: Cover,
    pageLayout: PageLayout,
    theme: Theme,
    column: Column,
    column_list: ColumnList,
    numbered_list_item: NumberedListItem,
    bulleted_list_item: BulletedListItem,
    to_do: Todo,
    toggle: Toggle,
    quote: Quote,
    callout: Callout,
    equation: Equation,
    code: Code,
    image: Image,
    video: Video,
    divider: Divider,
    audio: Audio,
    // low level custom. 넣을까 말까 고민중.., 
    checkbox: CheckBox,
    text: Text,
};
export const defaultProvider = new NotionComponentProvider({});
